/*
 * G2S web API
 * A Genome to Strucure (G2S) API Supports Automated Mapping and Annotating Genomic Variants in 3D Protein Structures. Supports Inputs from Human Genome Position, Uniprot and Human Ensembl Names.
 *
 * OpenAPI spec version: 1.0 (beta)
 * Contact: wangjue@missouri.edu
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.genomenexus.g2s.client.api;

import org.genomenexus.g2s.client.ApiCallback;
import org.genomenexus.g2s.client.ApiClient;
import org.genomenexus.g2s.client.ApiException;
import org.genomenexus.g2s.client.ApiResponse;
import org.genomenexus.g2s.client.Configuration;
import org.genomenexus.g2s.client.Pair;
import org.genomenexus.g2s.client.ProgressRequestBody;
import org.genomenexus.g2s.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.genomenexus.g2s.client.model.Alignment;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GetResidueMappingApi {
    private ApiClient apiClient;

    public GetResidueMappingApi() {
        this(Configuration.getDefaultApiClient());
    }

    public GetResidueMappingApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for getPdbAlignmentReisudeBySequenceUsingGET */
    private com.squareup.okhttp.Call getPdbAlignmentReisudeBySequenceUsingGETCall(String sequence, List<String> positionList, List<String> paramList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/alignments/residueMapping".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (sequence != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sequence", sequence));
        if (positionList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "positionList", positionList));
        if (paramList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "paramList", paramList));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getPdbAlignmentReisudeBySequenceUsingGETValidateBeforeCall(String sequence, List<String> positionList, List<String> paramList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'sequence' is set
        if (sequence == null) {
            throw new ApiException("Missing the required parameter 'sequence' when calling getPdbAlignmentReisudeBySequenceUsingGET(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getPdbAlignmentReisudeBySequenceUsingGETCall(sequence, positionList, paramList, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get PDB Residue Mapping by Protein Sequence and Residue position
     * 
     * @param sequence Input Protein Sequence: ETGQSVNDPGNMSFVKETVDKLLKGYDIRLRPDFGGPP (required)
     * @param positionList Input Residue Positions e.g. 10,20 (optional)
     * @param paramList Default Blast Parameters:  Evalue&#x3D;1e-10,Wordsize&#x3D;3,Gapopen&#x3D;11,Gapextend&#x3D;1,  Matrix&#x3D;BLOSUM62,Comp_based_stats&#x3D;2, Threshold&#x3D;11,Windowsize&#x3D;40 (optional)
     * @return List&lt;Alignment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alignment> getPdbAlignmentReisudeBySequenceUsingGET(String sequence, List<String> positionList, List<String> paramList) throws ApiException {
        ApiResponse<List<Alignment>> resp = getPdbAlignmentReisudeBySequenceUsingGETWithHttpInfo(sequence, positionList, paramList);
        return resp.getData();
    }

    /**
     * Get PDB Residue Mapping by Protein Sequence and Residue position
     * 
     * @param sequence Input Protein Sequence: ETGQSVNDPGNMSFVKETVDKLLKGYDIRLRPDFGGPP (required)
     * @param positionList Input Residue Positions e.g. 10,20 (optional)
     * @param paramList Default Blast Parameters:  Evalue&#x3D;1e-10,Wordsize&#x3D;3,Gapopen&#x3D;11,Gapextend&#x3D;1,  Matrix&#x3D;BLOSUM62,Comp_based_stats&#x3D;2, Threshold&#x3D;11,Windowsize&#x3D;40 (optional)
     * @return ApiResponse&lt;List&lt;Alignment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alignment>> getPdbAlignmentReisudeBySequenceUsingGETWithHttpInfo(String sequence, List<String> positionList, List<String> paramList) throws ApiException {
        com.squareup.okhttp.Call call = getPdbAlignmentReisudeBySequenceUsingGETValidateBeforeCall(sequence, positionList, paramList, null, null);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get PDB Residue Mapping by Protein Sequence and Residue position (asynchronously)
     * 
     * @param sequence Input Protein Sequence: ETGQSVNDPGNMSFVKETVDKLLKGYDIRLRPDFGGPP (required)
     * @param positionList Input Residue Positions e.g. 10,20 (optional)
     * @param paramList Default Blast Parameters:  Evalue&#x3D;1e-10,Wordsize&#x3D;3,Gapopen&#x3D;11,Gapextend&#x3D;1,  Matrix&#x3D;BLOSUM62,Comp_based_stats&#x3D;2, Threshold&#x3D;11,Windowsize&#x3D;40 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getPdbAlignmentReisudeBySequenceUsingGETAsync(String sequence, List<String> positionList, List<String> paramList, final ApiCallback<List<Alignment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getPdbAlignmentReisudeBySequenceUsingGETValidateBeforeCall(sequence, positionList, paramList, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for getPdbAlignmentReisudeBySequenceUsingPOST */
    private com.squareup.okhttp.Call getPdbAlignmentReisudeBySequenceUsingPOSTCall(String sequence, List<String> positionList, List<String> paramList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/alignments/residueMapping".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (sequence != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "sequence", sequence));
        if (positionList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "positionList", positionList));
        if (paramList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "paramList", paramList));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getPdbAlignmentReisudeBySequenceUsingPOSTValidateBeforeCall(String sequence, List<String> positionList, List<String> paramList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'sequence' is set
        if (sequence == null) {
            throw new ApiException("Missing the required parameter 'sequence' when calling getPdbAlignmentReisudeBySequenceUsingPOST(Async)");
        }
        
        
        com.squareup.okhttp.Call call = getPdbAlignmentReisudeBySequenceUsingPOSTCall(sequence, positionList, paramList, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get PDB Residue Mapping by Protein Sequence and Residue position
     * 
     * @param sequence Input Protein Sequence: ETGQSVNDPGNMSFVKETVDKLLKGYDIRLRPDFGGPP (required)
     * @param positionList Input Residue Positions e.g. 10,20 (optional)
     * @param paramList Default Blast Parameters:  Evalue&#x3D;1e-10,Wordsize&#x3D;3,Gapopen&#x3D;11,Gapextend&#x3D;1,  Matrix&#x3D;BLOSUM62,Comp_based_stats&#x3D;2, Threshold&#x3D;11,Windowsize&#x3D;40 (optional)
     * @return List&lt;Alignment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alignment> getPdbAlignmentReisudeBySequenceUsingPOST(String sequence, List<String> positionList, List<String> paramList) throws ApiException {
        ApiResponse<List<Alignment>> resp = getPdbAlignmentReisudeBySequenceUsingPOSTWithHttpInfo(sequence, positionList, paramList);
        return resp.getData();
    }

    /**
     * Get PDB Residue Mapping by Protein Sequence and Residue position
     * 
     * @param sequence Input Protein Sequence: ETGQSVNDPGNMSFVKETVDKLLKGYDIRLRPDFGGPP (required)
     * @param positionList Input Residue Positions e.g. 10,20 (optional)
     * @param paramList Default Blast Parameters:  Evalue&#x3D;1e-10,Wordsize&#x3D;3,Gapopen&#x3D;11,Gapextend&#x3D;1,  Matrix&#x3D;BLOSUM62,Comp_based_stats&#x3D;2, Threshold&#x3D;11,Windowsize&#x3D;40 (optional)
     * @return ApiResponse&lt;List&lt;Alignment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alignment>> getPdbAlignmentReisudeBySequenceUsingPOSTWithHttpInfo(String sequence, List<String> positionList, List<String> paramList) throws ApiException {
        com.squareup.okhttp.Call call = getPdbAlignmentReisudeBySequenceUsingPOSTValidateBeforeCall(sequence, positionList, paramList, null, null);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get PDB Residue Mapping by Protein Sequence and Residue position (asynchronously)
     * 
     * @param sequence Input Protein Sequence: ETGQSVNDPGNMSFVKETVDKLLKGYDIRLRPDFGGPP (required)
     * @param positionList Input Residue Positions e.g. 10,20 (optional)
     * @param paramList Default Blast Parameters:  Evalue&#x3D;1e-10,Wordsize&#x3D;3,Gapopen&#x3D;11,Gapextend&#x3D;1,  Matrix&#x3D;BLOSUM62,Comp_based_stats&#x3D;2, Threshold&#x3D;11,Windowsize&#x3D;40 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getPdbAlignmentReisudeBySequenceUsingPOSTAsync(String sequence, List<String> positionList, List<String> paramList, final ApiCallback<List<Alignment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getPdbAlignmentReisudeBySequenceUsingPOSTValidateBeforeCall(sequence, positionList, paramList, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for postResidueMappingByPDBUsingGET */
    private com.squareup.okhttp.Call postResidueMappingByPDBUsingGETCall(String idType, String id, String pdbId, String chainId, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/alignments/{id_type}/{id}/pdb/{pdb_id}_{chain_id}/residueMapping".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "id_type" + "\\}", apiClient.escapeString(idType.toString()))
        .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
        .replaceAll("\\{" + "pdb_id" + "\\}", apiClient.escapeString(pdbId.toString()))
        .replaceAll("\\{" + "chain_id" + "\\}", apiClient.escapeString(chainId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (positionList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "positionList", positionList));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postResidueMappingByPDBUsingGETValidateBeforeCall(String idType, String id, String pdbId, String chainId, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'idType' is set
        if (idType == null) {
            throw new ApiException("Missing the required parameter 'idType' when calling postResidueMappingByPDBUsingGET(Async)");
        }
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling postResidueMappingByPDBUsingGET(Async)");
        }
        
        // verify the required parameter 'pdbId' is set
        if (pdbId == null) {
            throw new ApiException("Missing the required parameter 'pdbId' when calling postResidueMappingByPDBUsingGET(Async)");
        }
        
        // verify the required parameter 'chainId' is set
        if (chainId == null) {
            throw new ApiException("Missing the required parameter 'chainId' when calling postResidueMappingByPDBUsingGET(Async)");
        }
        
        
        com.squareup.okhttp.Call call = postResidueMappingByPDBUsingGETCall(idType, id, pdbId, chainId, positionList, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Post Residue Mapping by ProteinId, PDBId and Chain
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g.  ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param pdbId Input PDB Id e.g. 2fej (required)
     * @param chainId Input Chain e.g. A (required)
     * @param positionList Input Residue Positions e.g. 10,100 (Anynumber for hgvs); Return all residue mappings if none (optional)
     * @return List&lt;Alignment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alignment> postResidueMappingByPDBUsingGET(String idType, String id, String pdbId, String chainId, List<String> positionList) throws ApiException {
        ApiResponse<List<Alignment>> resp = postResidueMappingByPDBUsingGETWithHttpInfo(idType, id, pdbId, chainId, positionList);
        return resp.getData();
    }

    /**
     * Post Residue Mapping by ProteinId, PDBId and Chain
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g.  ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param pdbId Input PDB Id e.g. 2fej (required)
     * @param chainId Input Chain e.g. A (required)
     * @param positionList Input Residue Positions e.g. 10,100 (Anynumber for hgvs); Return all residue mappings if none (optional)
     * @return ApiResponse&lt;List&lt;Alignment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alignment>> postResidueMappingByPDBUsingGETWithHttpInfo(String idType, String id, String pdbId, String chainId, List<String> positionList) throws ApiException {
        com.squareup.okhttp.Call call = postResidueMappingByPDBUsingGETValidateBeforeCall(idType, id, pdbId, chainId, positionList, null, null);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Post Residue Mapping by ProteinId, PDBId and Chain (asynchronously)
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g.  ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param pdbId Input PDB Id e.g. 2fej (required)
     * @param chainId Input Chain e.g. A (required)
     * @param positionList Input Residue Positions e.g. 10,100 (Anynumber for hgvs); Return all residue mappings if none (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postResidueMappingByPDBUsingGETAsync(String idType, String id, String pdbId, String chainId, List<String> positionList, final ApiCallback<List<Alignment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postResidueMappingByPDBUsingGETValidateBeforeCall(idType, id, pdbId, chainId, positionList, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for postResidueMappingByPDBUsingPOST */
    private com.squareup.okhttp.Call postResidueMappingByPDBUsingPOSTCall(String idType, String id, String pdbId, String chainId, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/alignments/{id_type}/{id}/pdb/{pdb_id}_{chain_id}/residueMapping".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "id_type" + "\\}", apiClient.escapeString(idType.toString()))
        .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
        .replaceAll("\\{" + "pdb_id" + "\\}", apiClient.escapeString(pdbId.toString()))
        .replaceAll("\\{" + "chain_id" + "\\}", apiClient.escapeString(chainId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (positionList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "positionList", positionList));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postResidueMappingByPDBUsingPOSTValidateBeforeCall(String idType, String id, String pdbId, String chainId, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'idType' is set
        if (idType == null) {
            throw new ApiException("Missing the required parameter 'idType' when calling postResidueMappingByPDBUsingPOST(Async)");
        }
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling postResidueMappingByPDBUsingPOST(Async)");
        }
        
        // verify the required parameter 'pdbId' is set
        if (pdbId == null) {
            throw new ApiException("Missing the required parameter 'pdbId' when calling postResidueMappingByPDBUsingPOST(Async)");
        }
        
        // verify the required parameter 'chainId' is set
        if (chainId == null) {
            throw new ApiException("Missing the required parameter 'chainId' when calling postResidueMappingByPDBUsingPOST(Async)");
        }
        
        
        com.squareup.okhttp.Call call = postResidueMappingByPDBUsingPOSTCall(idType, id, pdbId, chainId, positionList, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Post Residue Mapping by ProteinId, PDBId and Chain
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g.  ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param pdbId Input PDB Id e.g. 2fej (required)
     * @param chainId Input Chain e.g. A (required)
     * @param positionList Input Residue Positions e.g. 10,100 (Anynumber for hgvs); Return all residue mappings if none (optional)
     * @return List&lt;Alignment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alignment> postResidueMappingByPDBUsingPOST(String idType, String id, String pdbId, String chainId, List<String> positionList) throws ApiException {
        ApiResponse<List<Alignment>> resp = postResidueMappingByPDBUsingPOSTWithHttpInfo(idType, id, pdbId, chainId, positionList);
        return resp.getData();
    }

    /**
     * Post Residue Mapping by ProteinId, PDBId and Chain
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g.  ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param pdbId Input PDB Id e.g. 2fej (required)
     * @param chainId Input Chain e.g. A (required)
     * @param positionList Input Residue Positions e.g. 10,100 (Anynumber for hgvs); Return all residue mappings if none (optional)
     * @return ApiResponse&lt;List&lt;Alignment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alignment>> postResidueMappingByPDBUsingPOSTWithHttpInfo(String idType, String id, String pdbId, String chainId, List<String> positionList) throws ApiException {
        com.squareup.okhttp.Call call = postResidueMappingByPDBUsingPOSTValidateBeforeCall(idType, id, pdbId, chainId, positionList, null, null);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Post Residue Mapping by ProteinId, PDBId and Chain (asynchronously)
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g.  ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param pdbId Input PDB Id e.g. 2fej (required)
     * @param chainId Input Chain e.g. A (required)
     * @param positionList Input Residue Positions e.g. 10,100 (Anynumber for hgvs); Return all residue mappings if none (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postResidueMappingByPDBUsingPOSTAsync(String idType, String id, String pdbId, String chainId, List<String> positionList, final ApiCallback<List<Alignment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postResidueMappingByPDBUsingPOSTValidateBeforeCall(idType, id, pdbId, chainId, positionList, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for postResidueMappingUsingGET */
    private com.squareup.okhttp.Call postResidueMappingUsingGETCall(String idType, String id, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/alignments/{id_type}/{id}/residueMapping".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "id_type" + "\\}", apiClient.escapeString(idType.toString()))
        .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (positionList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "positionList", positionList));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postResidueMappingUsingGETValidateBeforeCall(String idType, String id, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'idType' is set
        if (idType == null) {
            throw new ApiException("Missing the required parameter 'idType' when calling postResidueMappingUsingGET(Async)");
        }
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling postResidueMappingUsingGET(Async)");
        }
        
        
        com.squareup.okhttp.Call call = postResidueMappingUsingGETCall(idType, id, positionList, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * POST PDB Residue Mapping by ProteinId
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g. ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param positionList Input Residue Positions e.g. 10,100; Anynumber for hgvs; Return all residue mappings if none (optional)
     * @return List&lt;Alignment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alignment> postResidueMappingUsingGET(String idType, String id, List<String> positionList) throws ApiException {
        ApiResponse<List<Alignment>> resp = postResidueMappingUsingGETWithHttpInfo(idType, id, positionList);
        return resp.getData();
    }

    /**
     * POST PDB Residue Mapping by ProteinId
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g. ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param positionList Input Residue Positions e.g. 10,100; Anynumber for hgvs; Return all residue mappings if none (optional)
     * @return ApiResponse&lt;List&lt;Alignment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alignment>> postResidueMappingUsingGETWithHttpInfo(String idType, String id, List<String> positionList) throws ApiException {
        com.squareup.okhttp.Call call = postResidueMappingUsingGETValidateBeforeCall(idType, id, positionList, null, null);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * POST PDB Residue Mapping by ProteinId (asynchronously)
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g. ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param positionList Input Residue Positions e.g. 10,100; Anynumber for hgvs; Return all residue mappings if none (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postResidueMappingUsingGETAsync(String idType, String id, List<String> positionList, final ApiCallback<List<Alignment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postResidueMappingUsingGETValidateBeforeCall(idType, id, positionList, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for postResidueMappingUsingPOST */
    private com.squareup.okhttp.Call postResidueMappingUsingPOSTCall(String idType, String id, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/alignments/{id_type}/{id}/residueMapping".replaceAll("\\{format\\}","json")
        .replaceAll("\\{" + "id_type" + "\\}", apiClient.escapeString(idType.toString()))
        .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (positionList != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("multi", "positionList", positionList));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call postResidueMappingUsingPOSTValidateBeforeCall(String idType, String id, List<String> positionList, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'idType' is set
        if (idType == null) {
            throw new ApiException("Missing the required parameter 'idType' when calling postResidueMappingUsingPOST(Async)");
        }
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling postResidueMappingUsingPOST(Async)");
        }
        
        
        com.squareup.okhttp.Call call = postResidueMappingUsingPOSTCall(idType, id, positionList, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * POST PDB Residue Mapping by ProteinId
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g. ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param positionList Input Residue Positions e.g. 10,100; Anynumber for hgvs; Return all residue mappings if none (optional)
     * @return List&lt;Alignment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alignment> postResidueMappingUsingPOST(String idType, String id, List<String> positionList) throws ApiException {
        ApiResponse<List<Alignment>> resp = postResidueMappingUsingPOSTWithHttpInfo(idType, id, positionList);
        return resp.getData();
    }

    /**
     * POST PDB Residue Mapping by ProteinId
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g. ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param positionList Input Residue Positions e.g. 10,100; Anynumber for hgvs; Return all residue mappings if none (optional)
     * @return ApiResponse&lt;List&lt;Alignment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alignment>> postResidueMappingUsingPOSTWithHttpInfo(String idType, String id, List<String> positionList) throws ApiException {
        com.squareup.okhttp.Call call = postResidueMappingUsingPOSTValidateBeforeCall(idType, id, positionList, null, null);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * POST PDB Residue Mapping by ProteinId (asynchronously)
     * 
     * @param idType Input id_type: ensembl; uniprot; uniprot_isoform; hgvs-grch37; hgvs-grch38 (required)
     * @param id Input id e.g. ensembl:ENSP00000484409.1/ENSG00000141510.16/ENST00000504290.5; uniprot:P04637/P53_HUMAN; uniprot_isoform:P04637_9/P53_HUMAN_9; hgvs-grch37:17:g.79478130C&gt;G; hgvs-grch38:17:g.7676594T&gt;G (required)
     * @param positionList Input Residue Positions e.g. 10,100; Anynumber for hgvs; Return all residue mappings if none (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call postResidueMappingUsingPOSTAsync(String idType, String id, List<String> positionList, final ApiCallback<List<Alignment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = postResidueMappingUsingPOSTValidateBeforeCall(idType, id, positionList, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alignment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
